// DO NOT EDIT
// Generated by JFlex 1.9.1 http://jflex.de/
// source: jflex/S164_ReferencesMinistries.jflex

/*******************************************************************************
 * Copyright (c) 2022-2029 Institute of Legal Information and Judicial Systems (IGSG-CNR)
 * 
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and 
 * limitations under the License.
 *  
 * Authors: Lorenzo Bacci (IGSG-CNR)
 ******************************************************************************/
package it.cnr.igsg.linkoln;

import java.util.ArrayList;


@SuppressWarnings("fallthrough")
class S164_ReferencesMinistries extends LinkolnAnnotationService {

  /** This character denotes the end of file. */
  public static final int YYEOF = -1;

  /** Initial size of the lookahead buffer. */
  private static final int ZZ_BUFFERSIZE = 16384;

  // Lexical states.
  public static final int YYINITIAL = 0;
  public static final int lkn = 2;
  public static final int referenceState = 4;

  /**
   * ZZ_LEXSTATE[l] is the state in the DFA for the lexical state l
   * ZZ_LEXSTATE[l+1] is the state in the DFA for the lexical state l
   *                  at the beginning of a line
   * l is of the form l = 2*k, k a non negative integer
   */
  private static final int ZZ_LEXSTATE[] = {
     0,  0,  1,  1,  2, 2
  };

  /**
   * Top-level table for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_TOP = zzUnpackcmap_top();

  private static final String ZZ_CMAP_TOP_PACKED_0 =
    "\1\0\1\u0100\36\u0200\1\u0300\1\u0400\u10de\u0200";

  private static int [] zzUnpackcmap_top() {
    int [] result = new int[4352];
    int offset = 0;
    offset = zzUnpackcmap_top(ZZ_CMAP_TOP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_top(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Second-level tables for translating characters to character classes
   */
  private static final int [] ZZ_CMAP_BLOCKS = zzUnpackcmap_blocks();

  private static final String ZZ_CMAP_BLOCKS_PACKED_0 =
    "\11\0\1\1\1\2\1\0\1\1\1\2\22\0\1\1"+
    "\1\0\1\3\3\0\1\4\1\0\2\1\2\0\2\1"+
    "\1\0\1\5\12\6\1\7\1\10\5\0\1\11\1\12"+
    "\1\13\1\14\1\15\1\16\1\17\1\20\1\21\1\22"+
    "\1\23\1\24\1\25\1\26\1\27\1\30\1\22\1\31"+
    "\1\32\1\33\1\34\1\35\1\36\1\22\1\37\1\22"+
    "\1\40\1\0\1\41\1\0\1\42\1\0\1\43\1\44"+
    "\1\45\1\46\1\47\1\50\1\51\1\52\1\53\1\0"+
    "\1\54\1\55\1\56\1\57\1\60\1\61\1\0\1\62"+
    "\1\63\1\64\1\65\1\66\1\67\1\0\1\70\266\0"+
    "\2\53\115\0\1\63\u0182\0\1\1\20\0\2\1\u0115\0"+
    "\1\54\325\0";

  private static int [] zzUnpackcmap_blocks() {
    int [] result = new int[1280];
    int offset = 0;
    offset = zzUnpackcmap_blocks(ZZ_CMAP_BLOCKS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackcmap_blocks(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /**
   * Translates DFA states to action switch labels.
   */
  private static final int [] ZZ_ACTION = zzUnpackAction();

  private static final String ZZ_ACTION_PACKED_0 =
    "\3\0\2\1\2\2\2\3\12\0\1\4\62\0\1\5"+
    "\203\0\1\5\11\0\1\6\7\0\1\7\4\0\1\10"+
    "\1\11\u010c\0\2\12\11\0\1\12\146\0\1\12";

  private static int [] zzUnpackAction() {
    int [] result = new int[610];
    int offset = 0;
    offset = zzUnpackAction(ZZ_ACTION_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAction(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /**
   * Translates a state to a row index in the transition table
   */
  private static final int [] ZZ_ROWMAP = zzUnpackRowMap();

  private static final String ZZ_ROWMAP_PACKED_0 =
    "\0\0\0\71\0\162\0\253\0\344\0\253\0\u011d\0\253"+
    "\0\u0156\0\u018f\0\u01c8\0\u0201\0\u023a\0\u0273\0\u02ac\0\u02e5"+
    "\0\u031e\0\u0357\0\u0390\0\253\0\u03c9\0\u0402\0\u043b\0\u0474"+
    "\0\u04ad\0\u04e6\0\u051f\0\u0558\0\u0591\0\u05ca\0\u0603\0\u063c"+
    "\0\u0675\0\u06ae\0\u06e7\0\u0720\0\u0759\0\u0792\0\u07cb\0\u0804"+
    "\0\u083d\0\u0876\0\u08af\0\u08e8\0\u0921\0\u095a\0\u0993\0\u09cc"+
    "\0\u0a05\0\u0a3e\0\u0a77\0\u0ab0\0\u0ae9\0\u0b22\0\u0b5b\0\u0b94"+
    "\0\u0bcd\0\u0c06\0\u0c3f\0\u0c78\0\u0cb1\0\u0cea\0\u0d23\0\u0d5c"+
    "\0\u0d95\0\u0dce\0\u0e07\0\u0e40\0\u0e79\0\u0eb2\0\253\0\u0eeb"+
    "\0\u0f24\0\u0f5d\0\u0f96\0\u0fcf\0\u1008\0\u1041\0\u107a\0\u10b3"+
    "\0\u10ec\0\u1125\0\u115e\0\u1197\0\u11d0\0\u1209\0\u1242\0\u127b"+
    "\0\u12b4\0\u12ed\0\u1326\0\u135f\0\u1398\0\u13d1\0\u140a\0\u1443"+
    "\0\u147c\0\u14b5\0\u14ee\0\u1527\0\u1560\0\u1599\0\u15d2\0\u160b"+
    "\0\u1644\0\u167d\0\u16b6\0\u16ef\0\u1728\0\u1761\0\u179a\0\u17d3"+
    "\0\u180c\0\u1845\0\u187e\0\u18b7\0\u18f0\0\u1929\0\u1962\0\u199b"+
    "\0\u19d4\0\u1a0d\0\u1a46\0\u1a7f\0\u1ab8\0\u1af1\0\u1b2a\0\u1b63"+
    "\0\u1b9c\0\u1bd5\0\u1c0e\0\u1c47\0\u1c80\0\u1cb9\0\u1cf2\0\u1d2b"+
    "\0\u1d64\0\u1d9d\0\u1dd6\0\u1e0f\0\u1e48\0\u1e81\0\u1eba\0\u1ef3"+
    "\0\u1f2c\0\u1f65\0\u1f9e\0\u1fd7\0\u2010\0\u2049\0\u2082\0\u20bb"+
    "\0\u20f4\0\u212d\0\u2166\0\u219f\0\u21d8\0\u2211\0\u224a\0\u2283"+
    "\0\u22bc\0\u22f5\0\u232e\0\u2367\0\u23a0\0\u23d9\0\u2412\0\u244b"+
    "\0\u2484\0\u24bd\0\u24f6\0\u252f\0\u2568\0\u25a1\0\u25da\0\u2613"+
    "\0\u264c\0\u2685\0\u26be\0\u26f7\0\u2730\0\u2769\0\u27a2\0\u27db"+
    "\0\u2814\0\u284d\0\u2886\0\u28bf\0\u28f8\0\u2931\0\u296a\0\u29a3"+
    "\0\u29dc\0\u2a15\0\u2a4e\0\u2a87\0\u2ac0\0\u2af9\0\u2b32\0\u2b6b"+
    "\0\u2ba4\0\u2bdd\0\u2c16\0\u2c16\0\u2c4f\0\u2c88\0\u2cc1\0\u2cfa"+
    "\0\u2d33\0\u2d6c\0\u2da5\0\u2dde\0\253\0\u2e17\0\u2e50\0\u2e89"+
    "\0\u2ec2\0\u2efb\0\u2f34\0\u2f6d\0\253\0\u2fa6\0\u2fdf\0\u3018"+
    "\0\u3051\0\253\0\253\0\u308a\0\u30c3\0\u30fc\0\u3135\0\u316e"+
    "\0\u31a7\0\u31e0\0\u3219\0\u3252\0\u328b\0\u32c4\0\u32fd\0\u3336"+
    "\0\u336f\0\u33a8\0\u33e1\0\u341a\0\u3453\0\u348c\0\u34c5\0\u34fe"+
    "\0\u3537\0\u3570\0\u35a9\0\u35e2\0\u361b\0\u3654\0\u368d\0\u36c6"+
    "\0\u36ff\0\u3738\0\u3771\0\u37aa\0\u37e3\0\u381c\0\u3855\0\u388e"+
    "\0\u38c7\0\u3900\0\u3939\0\u3972\0\u39ab\0\u39e4\0\u3a1d\0\u3a56"+
    "\0\u3a8f\0\u3ac8\0\u3b01\0\u3b3a\0\u3b73\0\u3bac\0\u3be5\0\u3c1e"+
    "\0\u3c57\0\u3c90\0\u3cc9\0\u3d02\0\u3d3b\0\u3d74\0\u3dad\0\u3de6"+
    "\0\u3e1f\0\u3e58\0\u3e91\0\u3eca\0\u3f03\0\u3f3c\0\u3f75\0\u3fae"+
    "\0\u3fe7\0\u4020\0\u4059\0\u4092\0\u40cb\0\u4104\0\u413d\0\u4176"+
    "\0\u41af\0\u41e8\0\u4221\0\u425a\0\u4293\0\u42cc\0\u4305\0\u433e"+
    "\0\u4377\0\u43b0\0\u43e9\0\u4422\0\u445b\0\u4494\0\u44cd\0\u4506"+
    "\0\u453f\0\u4578\0\u45b1\0\u45ea\0\u4623\0\u465c\0\u4695\0\u46ce"+
    "\0\u4707\0\u4740\0\u4779\0\u47b2\0\u47eb\0\u4824\0\u485d\0\u4896"+
    "\0\u48cf\0\u4908\0\u4941\0\u497a\0\u49b3\0\u49ec\0\u4a25\0\u4a5e"+
    "\0\u4a97\0\u4ad0\0\u4b09\0\u4b42\0\u4b7b\0\u4bb4\0\u4bed\0\u4c26"+
    "\0\u4c5f\0\u4c98\0\u4cd1\0\u4d0a\0\u4d43\0\u4d7c\0\u4db5\0\u4dee"+
    "\0\u4e27\0\u4e60\0\u4e99\0\u4ed2\0\u4f0b\0\u4f44\0\u4f7d\0\u4fb6"+
    "\0\u4fef\0\u5028\0\u5061\0\u509a\0\u50d3\0\u510c\0\u5145\0\u517e"+
    "\0\u51b7\0\u51f0\0\u5229\0\u5262\0\u529b\0\u52d4\0\u530d\0\u5346"+
    "\0\u537f\0\u53b8\0\u53f1\0\u542a\0\u5463\0\u549c\0\u54d5\0\u550e"+
    "\0\u5547\0\u5580\0\u55b9\0\u55f2\0\u562b\0\u5664\0\u569d\0\u56d6"+
    "\0\u570f\0\u5748\0\u5781\0\u57ba\0\u57f3\0\u582c\0\u5865\0\u589e"+
    "\0\u58d7\0\u5910\0\u5949\0\u5982\0\u59bb\0\u59f4\0\u5a2d\0\u5a66"+
    "\0\u5a9f\0\u5ad8\0\u5b11\0\u5b4a\0\u5b83\0\u5bbc\0\u5bf5\0\u5c2e"+
    "\0\u5c67\0\u5ca0\0\u5cd9\0\u5d12\0\u5d4b\0\u5d84\0\u5dbd\0\u5df6"+
    "\0\u5e2f\0\u5e68\0\u5ea1\0\u5eda\0\u5f13\0\u5f4c\0\u5f85\0\u5fbe"+
    "\0\u5ff7\0\u6030\0\u6069\0\u60a2\0\u60db\0\u6114\0\u614d\0\u6186"+
    "\0\u61bf\0\u61f8\0\u6231\0\u626a\0\u62a3\0\u62dc\0\u6315\0\u634e"+
    "\0\u6387\0\u63c0\0\u63f9\0\u6432\0\u646b\0\u64a4\0\u64dd\0\u6516"+
    "\0\u654f\0\u6588\0\u65c1\0\u65fa\0\u6633\0\u666c\0\u66a5\0\u66de"+
    "\0\u6717\0\u6750\0\u6789\0\u67c2\0\u67fb\0\u6834\0\u686d\0\u68a6"+
    "\0\u68df\0\u6918\0\u6951\0\u698a\0\u69c3\0\u69fc\0\u6a35\0\u6a6e"+
    "\0\u6aa7\0\u6ae0\0\u6b19\0\u6b52\0\u6b8b\0\u6bc4\0\u6bfd\0\u4695"+
    "\0\253\0\u6c36\0\u6c6f\0\u6ca8\0\u6ce1\0\u6d1a\0\u6d53\0\u6d8c"+
    "\0\u6dc5\0\u6dfe\0\u6e37\0\u6e70\0\u6e37\0\u6ea9\0\u6ee2\0\u6f1b"+
    "\0\u6f54\0\u6f8d\0\u6fc6\0\u6fff\0\u7038\0\u7071\0\u70aa\0\u70e3"+
    "\0\u711c\0\u7155\0\u718e\0\u71c7\0\u7200\0\u7239\0\u7272\0\u72ab"+
    "\0\u72e4\0\u731d\0\u7356\0\u738f\0\u73c8\0\u7401\0\u743a\0\u7473"+
    "\0\u74ac\0\u74e5\0\u751e\0\u7557\0\u7590\0\u75c9\0\u7602\0\u763b"+
    "\0\u7674\0\u76ad\0\u76e6\0\u771f\0\u7758\0\u7791\0\u77ca\0\u7803"+
    "\0\u783c\0\u7875\0\u78ae\0\u78e7\0\u7920\0\u7959\0\u7992\0\u79cb"+
    "\0\u7a04\0\u7a3d\0\u7a76\0\u7aaf\0\u7ae8\0\u7b21\0\u7b5a\0\u7b93"+
    "\0\u7bcc\0\u7c05\0\u7c3e\0\u7c77\0\u7cb0\0\u7ce9\0\u7d22\0\u7d5b"+
    "\0\u7d94\0\u7dcd\0\u7e06\0\u7e3f\0\u7e78\0\u7eb1\0\u7eea\0\u7f23"+
    "\0\u7f5c\0\u7f95\0\u7fce\0\u8007\0\u8040\0\u8079\0\u80b2\0\u80eb"+
    "\0\u8124\0\u815d\0\u8196\0\u81cf\0\u8208\0\u8241\0\u827a\0\u82b3"+
    "\0\u82ec\0\u8325\0\u835e\0\u8397\0\u83d0\0\u8409\0\u8442\0\u847b"+
    "\0\u84b4\0\u6f54";

  private static int [] zzUnpackRowMap() {
    int [] result = new int[610];
    int offset = 0;
    offset = zzUnpackRowMap(ZZ_ROWMAP_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackRowMap(String packed, int offset, int [] result) {
    int i = 0;  /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length() - 1;
    while (i < l) {
      int high = packed.charAt(i++) << 16;
      result[j++] = high | packed.charAt(i++);
    }
    return j;
  }

  /**
   * The transition table of the DFA
   */
  private static final int [] ZZ_TRANS = zzUnpacktrans();

  private static final String ZZ_TRANS_PACKED_0 =
    "\40\4\1\5\30\4\40\6\1\7\30\6\40\10\1\11"+
    "\30\10\115\0\1\12\30\0\1\12\20\0\1\13\107\0"+
    "\1\14\30\0\1\14\36\0\1\15\30\0\1\15\40\0"+
    "\1\16\30\0\1\16\36\0\1\17\30\0\1\17\42\0"+
    "\1\20\30\0\1\20\34\0\1\21\30\0\1\21\42\0"+
    "\1\22\30\0\1\22\20\0\1\23\107\0\1\24\30\0"+
    "\1\24\20\0\1\25\72\0\3\26\1\27\7\26\1\30"+
    "\13\26\2\0\1\26\3\0\1\31\6\0\1\32\24\0"+
    "\1\33\2\0\1\34\1\0\1\35\5\0\1\36\1\37"+
    "\1\40\3\0\1\41\10\0\1\33\2\0\1\34\1\0"+
    "\1\35\4\0\1\36\1\37\1\40\3\0\1\41\14\0"+
    "\1\42\1\0\27\26\2\0\1\26\35\0\1\42\1\0"+
    "\16\26\1\43\10\26\2\0\1\26\15\0\1\44\17\0"+
    "\1\42\1\0\4\26\1\45\22\26\2\0\1\26\4\0"+
    "\1\46\50\0\1\44\30\0\1\44\25\0\1\46\31\0"+
    "\1\46\55\0\1\47\30\0\1\47\32\0\1\50\30\0"+
    "\1\50\44\0\1\51\30\0\1\51\20\0\1\52\31\0"+
    "\1\52\42\0\1\53\31\0\1\53\51\0\1\54\30\0"+
    "\1\54\36\0\1\55\30\0\1\55\4\0\2\42\2\0"+
    "\3\42\1\56\30\42\2\0\27\42\7\0\1\42\1\0"+
    "\2\26\1\57\24\26\2\0\1\26\2\0\1\60\36\0"+
    "\1\60\31\0\1\60\32\0\1\42\1\0\6\26\1\61"+
    "\20\26\2\0\1\26\6\0\1\62\36\0\1\62\31\0"+
    "\1\62\52\0\1\63\30\0\1\63\17\0\1\64\31\0"+
    "\1\64\47\0\1\65\30\0\1\65\32\0\1\66\31\0"+
    "\1\66\45\0\1\67\30\0\1\67\36\0\1\70\30\0"+
    "\1\70\42\0\1\71\30\0\1\71\15\0\1\72\71\0"+
    "\1\42\1\0\22\26\1\73\4\26\2\0\1\26\21\0"+
    "\1\74\37\0\1\74\30\0\1\74\13\0\1\42\1\0"+
    "\27\26\2\0\1\75\70\0\1\76\46\0\1\77\31\0"+
    "\1\77\51\0\1\100\6\0\1\101\21\0\1\100\30\0"+
    "\1\102\30\0\1\102\55\0\1\103\47\0\1\104\31\0"+
    "\1\104\27\0\1\105\31\0\1\105\62\0\1\106\30\0"+
    "\1\106\7\0\1\72\32\0\1\107\36\0\1\42\1\0"+
    "\26\26\1\110\2\0\1\26\25\0\1\111\37\0\1\111"+
    "\30\0\1\111\7\0\1\42\1\0\3\26\1\27\23\26"+
    "\2\0\1\26\3\0\1\31\36\0\1\31\31\0\1\31"+
    "\31\0\1\112\120\0\1\113\30\0\1\113\14\0\1\114"+
    "\31\0\1\114\64\0\1\115\37\0\1\33\2\0\1\116"+
    "\26\0\1\33\2\0\1\116\54\0\1\117\30\0\1\117"+
    "\22\0\1\120\31\0\1\120\30\0\1\121\70\0\1\42"+
    "\1\0\17\26\1\122\7\26\2\0\1\26\16\0\1\123"+
    "\37\0\1\123\30\0\1\123\34\0\1\124\30\0\1\124"+
    "\42\0\1\125\30\0\1\125\20\0\1\126\31\0\1\126"+
    "\53\0\1\127\30\0\1\127\40\0\1\130\30\0\1\130"+
    "\43\0\1\131\30\0\1\131\35\0\1\132\30\0\1\132"+
    "\6\0\2\121\2\0\3\121\1\133\30\121\2\0\27\121"+
    "\7\0\1\42\1\0\4\26\1\134\22\26\2\0\1\26"+
    "\4\0\1\135\36\0\1\135\31\0\1\135\42\0\1\136"+
    "\31\0\1\136\32\0\1\137\31\0\1\137\54\0\1\140"+
    "\30\0\1\140\40\0\1\141\30\0\1\141\16\0\1\142"+
    "\31\0\1\142\54\0\1\143\30\0\1\143\15\0\1\144"+
    "\32\0\1\145\34\0\1\146\71\0\1\147\1\0\27\26"+
    "\2\0\1\26\35\0\1\150\107\0\1\151\30\0\1\151"+
    "\20\0\1\152\76\0\1\153\31\0\1\153\46\0\1\154"+
    "\30\0\1\154\45\0\1\100\30\0\1\100\43\0\1\155"+
    "\30\0\1\155\2\144\2\0\3\144\1\156\30\144\2\0"+
    "\27\144\37\0\1\157\30\0\1\157\6\0\1\146\32\0"+
    "\1\160\27\0\2\42\2\0\3\42\1\56\3\42\1\161"+
    "\1\162\11\42\1\163\1\164\1\165\1\166\6\42\2\0"+
    "\3\42\1\161\1\162\10\42\1\163\1\164\1\165\1\166"+
    "\6\42\13\0\1\167\1\170\11\0\1\171\1\172\1\173"+
    "\1\174\13\0\1\167\1\170\10\0\1\171\1\172\1\173"+
    "\1\174\27\0\1\175\31\0\1\175\30\0\1\176\1\177"+
    "\11\0\1\200\1\201\1\202\1\203\13\0\1\176\1\177"+
    "\10\0\1\200\1\201\1\202\1\203\15\0\1\204\73\0"+
    "\1\205\31\0\1\205\33\0\1\206\67\0\1\207\77\0"+
    "\1\210\31\0\1\210\21\0\40\211\1\0\30\211\2\42"+
    "\2\0\3\42\1\56\11\42\1\212\16\42\2\0\11\42"+
    "\1\212\17\42\2\0\3\42\1\56\5\42\1\213\22\42"+
    "\2\0\5\42\1\213\23\42\2\0\3\42\1\56\17\42"+
    "\1\214\10\42\2\0\16\42\1\214\12\42\2\0\3\42"+
    "\1\56\21\42\1\215\6\42\2\0\20\42\1\215\10\42"+
    "\2\0\3\42\1\56\21\42\1\216\6\42\2\0\20\42"+
    "\1\216\10\42\2\0\3\42\1\56\5\42\1\217\3\42"+
    "\1\220\16\42\2\0\5\42\1\217\3\42\1\220\15\42"+
    "\21\0\1\221\31\0\1\221\32\0\1\222\31\0\1\222"+
    "\50\0\1\223\30\0\1\223\41\0\1\224\30\0\1\224"+
    "\37\0\1\225\30\0\1\225\23\0\1\226\3\0\1\227"+
    "\25\0\1\226\3\0\1\227\47\0\1\230\30\0\1\230"+
    "\26\0\1\231\31\0\1\231\32\0\1\232\31\0\1\232"+
    "\50\0\1\233\30\0\1\233\41\0\1\234\30\0\1\234"+
    "\37\0\1\235\30\0\1\235\23\0\1\236\3\0\1\237"+
    "\25\0\1\236\3\0\1\237\15\0\2\204\2\0\3\204"+
    "\1\240\30\204\2\0\27\204\15\0\1\241\31\0\1\241"+
    "\21\0\2\206\2\0\3\206\1\242\30\206\2\0\27\206"+
    "\6\0\1\207\32\0\1\243\40\0\1\241\31\0\1\241"+
    "\25\0\40\211\1\244\30\211\2\42\2\0\3\42\1\56"+
    "\21\42\1\245\6\42\2\0\20\42\1\245\10\42\2\0"+
    "\3\42\1\56\3\42\1\246\24\42\2\0\3\42\1\246"+
    "\25\42\2\0\3\42\1\56\23\42\1\247\4\42\2\0"+
    "\22\42\1\247\6\42\2\0\3\42\1\56\4\42\1\250"+
    "\23\42\2\0\4\42\1\250\24\42\2\0\3\42\1\56"+
    "\17\42\1\251\10\42\2\0\16\42\1\251\12\42\2\0"+
    "\3\42\1\56\7\42\1\250\20\42\2\0\7\42\1\250"+
    "\21\42\2\0\3\42\1\56\22\42\1\250\5\42\2\0"+
    "\21\42\1\250\5\42\31\0\1\252\30\0\1\252\21\0"+
    "\1\253\31\0\1\253\56\0\1\254\30\0\1\254\20\0"+
    "\1\255\31\0\1\255\51\0\1\256\30\0\1\256\27\0"+
    "\1\255\31\0\1\255\51\0\1\255\30\0\1\255\40\0"+
    "\1\257\30\0\1\257\35\0\1\260\30\0\1\260\21\0"+
    "\1\261\31\0\1\261\56\0\1\262\30\0\1\262\20\0"+
    "\1\263\31\0\1\263\51\0\1\264\30\0\1\264\27\0"+
    "\1\263\31\0\1\263\51\0\1\263\30\0\1\263\13\0"+
    "\1\265\113\0\1\266\30\0\1\266\14\0\1\267\62\0"+
    "\40\270\1\0\30\270\5\0\1\271\63\0\2\42\2\0"+
    "\3\42\1\56\3\42\1\250\24\42\2\0\3\42\1\250"+
    "\25\42\2\0\3\42\1\56\21\42\1\250\6\42\2\0"+
    "\20\42\1\250\10\42\2\0\3\42\1\56\1\42\1\250"+
    "\26\42\2\0\1\42\1\250\27\42\2\0\3\42\1\272"+
    "\30\42\2\0\31\42\2\0\3\42\1\56\25\42\1\273"+
    "\2\42\2\0\24\42\1\273\2\42\13\0\1\255\31\0"+
    "\1\255\54\0\1\255\30\0\1\255\17\0\1\255\31\0"+
    "\1\255\34\0\1\274\116\0\1\275\30\0\1\275\17\0"+
    "\1\276\31\0\1\276\34\0\1\263\31\0\1\263\54\0"+
    "\1\263\30\0\1\263\17\0\1\263\31\0\1\263\34\0"+
    "\1\240\116\0\1\277\30\0\1\277\10\0\1\265\32\0"+
    "\1\300\36\0\1\144\67\0\1\267\32\0\1\301\27\0"+
    "\40\270\1\302\30\270\24\0\1\303\30\0\1\303\21\0"+
    "\1\304\62\0\2\42\2\0\3\42\1\56\25\42\1\250"+
    "\2\42\2\0\24\42\1\250\2\42\6\0\1\305\117\0"+
    "\1\255\30\0\1\255\33\0\1\306\30\0\1\306\43\0"+
    "\1\263\30\0\1\263\2\0\40\307\1\0\30\307\40\310"+
    "\1\0\30\310\5\0\1\311\106\0\1\312\30\0\1\312"+
    "\22\0\1\304\32\0\1\313\35\0\1\305\32\0\1\314"+
    "\56\0\1\263\30\0\1\263\10\0\40\307\1\315\30\307"+
    "\40\310\1\316\30\310\24\0\1\317\30\0\1\317\41\0"+
    "\1\320\30\0\1\320\11\0\40\321\1\0\30\321\5\0"+
    "\1\322\70\0\1\323\106\0\1\324\30\0\1\324\55\0"+
    "\1\325\27\0\40\321\1\326\30\321\24\0\1\327\30\0"+
    "\1\327\37\0\1\330\30\0\1\330\41\0\1\331\30\0"+
    "\1\331\16\0\1\332\106\0\1\333\30\0\1\333\37\0"+
    "\1\334\30\0\1\334\55\0\1\335\53\0\1\336\30\0"+
    "\1\336\41\0\1\337\30\0\1\337\37\0\1\340\30\0"+
    "\1\340\34\0\1\341\30\0\1\341\55\0\1\342\70\0"+
    "\1\343\55\0\1\344\30\0\1\344\52\0\1\345\30\0"+
    "\2\345\1\0\1\346\2\0\1\345\30\0\1\347\1\0"+
    "\1\345\54\0\1\350\30\0\1\350\35\0\1\351\30\0"+
    "\1\351\25\0\1\352\31\0\1\352\47\0\1\353\30\0"+
    "\1\353\46\0\1\354\30\0\1\354\33\0\1\355\30\0"+
    "\1\355\41\0\1\356\30\0\1\356\16\0\1\357\71\0"+
    "\1\345\71\0\1\360\2\0\1\361\1\0\1\362\5\0"+
    "\1\363\1\364\1\365\3\0\1\366\10\0\1\360\2\0"+
    "\1\361\1\0\1\362\4\0\1\363\1\364\1\365\3\0"+
    "\1\366\41\0\1\367\30\0\1\367\32\0\1\370\30\0"+
    "\1\370\44\0\1\371\30\0\1\371\20\0\1\372\31\0"+
    "\1\372\42\0\1\373\31\0\1\373\51\0\1\374\30\0"+
    "\1\374\36\0\1\375\30\0\1\375\37\0\1\376\30\0"+
    "\1\376\17\0\1\377\31\0\1\377\47\0\1\u0100\30\0"+
    "\1\u0100\32\0\1\u0101\31\0\1\u0101\45\0\1\u0102\30\0"+
    "\1\u0102\36\0\1\u0103\30\0\1\u0103\42\0\1\u0104\30\0"+
    "\1\u0104\27\0\1\u0105\31\0\1\u0105\60\0\1\u0106\52\0"+
    "\1\u0107\30\0\1\u0107\55\0\1\u0108\47\0\1\u0109\31\0"+
    "\1\u0109\27\0\1\u010a\31\0\1\u010a\62\0\1\u010b\30\0"+
    "\1\u010b\10\0\1\u010c\75\0\1\u010d\31\0\1\u010d\64\0"+
    "\1\u010e\37\0\1\360\31\0\1\360\57\0\1\u010f\30\0"+
    "\1\u010f\22\0\1\u0110\31\0\1\u0110\30\0\1\u0111\106\0"+
    "\1\u0112\30\0\1\u0112\23\0\1\u0113\31\0\1\u0113\53\0"+
    "\1\u0114\30\0\1\u0114\44\0\1\u0115\30\0\1\u0115\35\0"+
    "\1\u0116\30\0\1\u0116\6\0\2\u0111\2\0\3\u0111\1\274"+
    "\30\u0111\2\0\27\u0111\21\0\1\u0117\31\0\1\u0117\50\0"+
    "\1\u0118\30\0\1\u0118\40\0\1\u0119\30\0\1\u0119\34\0"+
    "\1\u011a\30\0\1\u011a\15\0\1\u011b\32\0\1\u011c\54\0"+
    "\1\u011d\30\0\1\u011d\26\0\1\u011e\31\0\1\u011e\46\0"+
    "\1\u011f\30\0\1\u011f\51\0\1\u0120\30\0\1\u0120\2\u011b"+
    "\2\0\3\u011b\1\u0121\30\u011b\2\0\27\u011b\37\0\1\u0122"+
    "\30\0\1\u0122\21\0\1\u0123\31\0\1\u0123\24\0\1\u011b"+
    "\73\0\1\u0124\31\0\1\u0124\33\0\1\u0125\67\0\1\u0126"+
    "\77\0\1\u0127\31\0\1\u0127\53\0\1\u0128\30\0\1\u0128"+
    "\22\0\1\u0129\31\0\1\u0129\21\0\2\u0125\2\0\3\u0125"+
    "\1\u012a\30\u0125\2\0\27\u0125\6\0\1\u0126\32\0\1\u012b"+
    "\40\0\1\u0129\31\0\1\u0129\60\0\1\u012c\30\0\1\u012c"+
    "\35\0\1\u011e\30\0\1\u011e\14\0\1\u012d\62\0\40\u012e"+
    "\1\0\30\u012e\15\0\1\u012f\31\0\1\u012f\27\0\1\u012d"+
    "\32\0\1\u0130\27\0\40\u012e\1\u0131\30\u012e\31\0\1\u0132"+
    "\30\0\1\u0132\6\0\40\u0133\1\0\30\u0133\5\0\1\u0134"+
    "\112\0\1\u0135\30\0\1\u0135\10\0\40\u0133\1\u0136\30\u0133"+
    "\24\0\1\u0137\30\0\1\u0137\22\0\1\u0138\66\0\1\u0139"+
    "\106\0\1\u013a\30\0\1\u013a\22\0\1\u013b\106\0\1\u013c"+
    "\30\0\1\u013c\41\0\1\u013d\30\0\1\u013d\17\0\1\u013b"+
    "\32\0\1\u013e\52\0\1\u013f\30\0\1\u013f\55\0\1\u0140"+
    "\27\0\40\u0141\1\0\30\u0141\26\0\1\u0142\30\0\1\u0142"+
    "\12\0\2\u0140\1\0\1\u0143\2\0\1\u0144\30\0\1\u0145"+
    "\1\0\1\u0140\26\0\40\u0141\1\u0146\30\u0141\41\0\1\u0147"+
    "\55\0\1\u0148\30\0\1\u0148\12\0\2\u0144\1\0\1\u0149"+
    "\2\0\1\u0144\30\0\1\u014a\1\0\1\u0144\52\0\1\u014b"+
    "\30\0\1\u014b\20\0\1\u014c\64\0\2\u0147\1\0\1\u014d"+
    "\2\0\1\u0147\30\0\1\u014e\1\0\1\u0147\40\0\1\u014f"+
    "\31\0\1\u014f\52\0\1\u0150\30\0\1\u0150\35\0\1\u0151"+
    "\30\0\1\u0151\36\0\1\u0152\30\0\1\u0152\40\0\1\u0153"+
    "\30\0\1\u0153\41\0\1\u0154\30\0\1\u0154\35\0\1\u0155"+
    "\30\0\1\u0155\45\0\1\u0156\30\0\1\u0156\17\0\1\u0157"+
    "\31\0\1\u0157\47\0\1\u0158\30\0\1\u0158\42\0\1\u0159"+
    "\30\0\1\u0159\34\0\1\u015a\30\0\1\u015a\26\0\1\u015b"+
    "\31\0\1\u015b\47\0\1\u015c\30\0\1\u015c\44\0\1\u015d"+
    "\30\0\1\u015d\41\0\1\u015e\30\0\1\u015e\33\0\1\u015f"+
    "\30\0\1\u015f\20\0\1\u0160\107\0\1\u0161\30\0\1\u0161"+
    "\43\0\1\u0162\30\0\1\u0162\33\0\1\u0163\30\0\1\u0163"+
    "\21\0\1\u0140\110\0\1\u0164\30\0\1\u0164\16\0\1\u0165"+
    "\75\0\1\361\1\0\1\362\6\0\1\u0166\1\365\3\0"+
    "\1\u0167\13\0\1\361\1\0\1\362\5\0\1\u0166\1\365"+
    "\3\0\1\u0167\46\0\1\u0168\57\0\1\u0169\30\0\1\u0169"+
    "\16\0\1\u016a\71\0\1\u0144\74\0\1\361\1\0\1\362"+
    "\7\0\1\365\3\0\1\u016b\13\0\1\361\1\0\1\362"+
    "\6\0\1\365\3\0\1\u016b\26\0\1\u016c\31\0\1\u016c"+
    "\50\0\1\u016d\30\0\1\u016d\5\0\2\u0168\1\0\1\u016e"+
    "\2\0\1\u0168\30\0\1\u016f\1\0\1\u0168\36\0\1\u0147"+
    "\74\0\1\u0170\1\0\1\u0171\7\0\1\u0172\3\0\1\u0173"+
    "\13\0\1\u0170\1\0\1\u0171\6\0\1\u0172\3\0\1\u0173"+
    "\40\0\1\u0174\30\0\1\u0174\32\0\1\u0175\30\0\1\u0175"+
    "\41\0\1\u0176\30\0\1\u0176\35\0\1\u0177\30\0\1\u0177"+
    "\35\0\1\u0178\30\0\1\u0178\42\0\1\u0179\30\0\1\u0179"+
    "\44\0\1\u017a\30\0\1\u017a\37\0\1\u017b\30\0\1\u017b"+
    "\36\0\1\u017c\30\0\1\u017c\34\0\1\u017d\30\0\1\u017d"+
    "\30\0\1\u017e\31\0\1\u017e\53\0\1\u011e\30\0\1\u011e"+
    "\13\0\1\u017f\31\0\1\u017f\47\0\1\u0180\30\0\1\u0180"+
    "\27\0\1\u0181\31\0\1\u0181\47\0\1\u0182\30\0\1\u0182"+
    "\40\0\1\u0183\30\0\1\u0183\42\0\1\u0184\30\0\1\u0184"+
    "\45\0\1\u0185\30\0\1\u0185\33\0\1\u0186\30\0\1\u0186"+
    "\37\0\1\u0187\30\0\1\u0187\33\0\1\u0188\30\0\1\u0188"+
    "\53\0\1\u0189\52\0\1\u018a\30\0\1\u018a\25\0\1\u018b"+
    "\31\0\1\u018b\62\0\1\u0120\30\0\1\u0120\10\0\1\u018c"+
    "\114\0\1\u018d\30\0\1\u018d\34\0\1\u018e\30\0\1\u018e"+
    "\16\0\1\u018f\75\0\1\u0190\31\0\1\u0190\64\0\1\u0191"+
    "\43\0\1\u0192\31\0\1\u0192\21\0\2\u018c\2\0\3\u018c"+
    "\1\u0193\30\u018c\2\0\27\u018c\31\0\1\u0194\30\0\1\u0194"+
    "\16\0\1\u0168\74\0\1\u0195\1\0\1\u0196\6\0\1\u0197"+
    "\1\u0198\3\0\1\u0199\13\0\1\u0195\1\0\1\u0196\5\0"+
    "\1\u0197\1\u0198\3\0\1\u0199\16\0\1\u019a\31\0\1\u019a"+
    "\53\0\1\u019b\30\0\1\u019b\42\0\1\u019c\30\0\1\u019c"+
    "\14\0\1\u019d\121\0\1\u019e\30\0\1\u019e\27\0\1\u019f"+
    "\30\0\1\u019f\44\0\1\u01a0\30\0\1\u01a0\24\0\1\u01a1"+
    "\31\0\1\u01a1\51\0\1\u01a2\30\0\1\u01a2\36\0\1\u01a3"+
    "\30\0\1\u01a3\37\0\1\u01a4\30\0\1\u01a4\40\0\1\u01a5"+
    "\30\0\1\u01a5\12\0\1\u01a6\32\0\1\u01a7\34\0\1\u019d"+
    "\32\0\1\u01a8\36\0\1\u01a9\74\0\1\u01aa\31\0\1\u01aa"+
    "\47\0\1\u01ab\30\0\1\u01ab\41\0\1\u01ac\30\0\1\u01ac"+
    "\36\0\1\u01ad\30\0\1\u01ad\42\0\1\u01ae\30\0\1\u01ae"+
    "\24\0\1\u01af\31\0\1\u01af\46\0\1\u01b0\30\0\1\u01b0"+
    "\12\0\2\u01a6\2\0\3\u01a6\1\u01b1\30\u01a6\2\0\27\u01a6"+
    "\37\0\1\u01b2\30\0\1\u01b2\40\u01b3\1\0\30\u01b3\2\u01a9"+
    "\2\0\3\u01a9\1\u01b4\30\u01a9\2\0\27\u01a9\42\0\1\u01b5"+
    "\52\0\1\u01b6\30\0\1\u01b6\34\0\1\u01b7\31\0\1\u01b7"+
    "\27\0\1\u01b8\31\0\1\u01b8\62\0\1\u01b9\30\0\1\u01b9"+
    "\10\0\1\u01a6\73\0\1\u01ba\31\0\1\u01ba\32\0\1\u01bb"+
    "\77\0\1\u01bc\31\0\1\u01bc\21\0\40\u01b3\1\u01bd\30\u01b3"+
    "\6\0\1\u01be\76\0\1\u01bf\31\0\1\u01bf\64\0\1\u01c0"+
    "\60\0\1\u01c1\30\0\1\u01c1\22\0\1\u01c2\31\0\1\u01c2"+
    "\30\0\1\u01c3\76\0\1\u01c4\31\0\1\u01c4\27\0\1\u01bb"+
    "\32\0\1\u01c5\40\0\1\u01c4\31\0\1\u01c4\32\0\1\u01c6"+
    "\71\0\1\u01be\32\0\1\u01c7\40\0\1\u01c8\31\0\1\u01c8"+
    "\53\0\1\u01c9\30\0\1\u01c9\44\0\1\u01ca\30\0\1\u01ca"+
    "\35\0\1\u01cb\30\0\1\u01cb\6\0\2\u01c3\2\0\3\u01c3"+
    "\1\u0138\30\u01c3\2\0\27\u01c3\31\0\1\u01af\30\0\1\u01af"+
    "\6\0\40\u01cc\1\0\30\u01cc\24\0\1\u01cd\30\0\1\u01cd"+
    "\13\0\40\u01ce\1\0\30\u01ce\33\0\1\u01cf\30\0\1\u01cf"+
    "\40\0\1\u01d0\30\0\1\u01d0\34\0\1\u01d1\30\0\1\u01d1"+
    "\15\0\1\u01d2\32\0\1\u01d3\26\0\40\u01cc\1\u01d4\30\u01cc"+
    "\23\0\1\u01d5\30\0\1\u01d5\14\0\40\u01ce\1\u01d6\30\u01ce"+
    "\15\0\1\u01d7\31\0\1\u01d7\46\0\1\u01d8\30\0\1\u01d8"+
    "\51\0\1\u01d9\30\0\1\u01d9\2\u01d2\2\0\3\u01d2\1\u01da"+
    "\30\u01d2\2\0\27\u01d2\37\0\1\u01db\30\0\1\u01db\5\0"+
    "\1\u01dc\111\0\1\u01dd\30\0\1\u01dd\16\0\1\u01de\72\0"+
    "\1\u01d2\73\0\1\u01df\31\0\1\u01df\33\0\1\u01e0\67\0"+
    "\1\u01e1\77\0\1\u01e2\31\0\1\u01e2\45\0\1\u01e3\30\0"+
    "\1\u01e3\54\0\1\u0144\53\0\1\u01e4\30\0\1\u01e4\30\0"+
    "\1\u01e5\31\0\1\u01e5\21\0\2\u01e0\2\0\3\u01e0\1\u01e6"+
    "\30\u01e0\2\0\27\u01e0\6\0\1\u01e1\32\0\1\u01e7\40\0"+
    "\1\u01e5\31\0\1\u01e5\50\0\1\u01e8\30\0\1\u01e8\37\0"+
    "\1\u01e9\30\0\1\u01e9\45\0\1\u01d7\30\0\1\u01d7\14\0"+
    "\1\u01ea\62\0\40\u01eb\1\0\30\u01eb\26\0\1\u01ec\30\0"+
    "\1\u01ec\37\0\1\u01ed\30\0\1\u01ed\17\0\1\u01ea\32\0"+
    "\1\u01ee\27\0\40\u01eb\1\u01ef\30\u01eb\41\0\1\u01f0\70\0"+
    "\1\u01f1\27\0\40\u01f2\1\0\30\u01f2\5\0\1\u01f3\63\0"+
    "\40\u01f2\1\u01f4\30\u01f2\24\0\1\u01f5\30\0\1\u01f5\20\0"+
    "\1\u01f6\106\0\1\u01f7\30\0\1\u01f7\40\0\1\u01f8\30\0"+
    "\1\u01f8\41\0\1\u01f9\30\0\1\u01f9\34\0\1\u01fa\30\0"+
    "\1\u01fa\55\0\1\u01fb\55\0\1\u01fc\30\0\1\u01fc\12\0"+
    "\2\u01fd\1\0\1\u01fe\2\0\1\u01ff\30\0\1\u0200\1\0"+
    "\1\u01fd\67\0\1\u0201\55\0\1\u0202\30\0\1\u0202\12\0"+
    "\2\u01ff\1\0\1\u0203\2\0\1\u01ff\30\0\1\u0204\1\0"+
    "\1\u01ff\52\0\1\u0205\30\0\1\u0205\14\0\2\u0201\1\0"+
    "\1\u0206\33\0\1\u0207\1\0\1\u0201\40\0\1\u0208\31\0"+
    "\1\u0208\52\0\1\u0209\30\0\1\u0209\35\0\1\u020a\30\0"+
    "\1\u020a\36\0\1\u020b\30\0\1\u020b\42\0\1\u020c\30\0"+
    "\1\u020c\35\0\1\u020d\30\0\1\u020d\45\0\1\u020e\30\0"+
    "\1\u020e\17\0\1\u020f\31\0\1\u020f\47\0\1\u0210\30\0"+
    "\1\u0210\42\0\1\u0211\30\0\1\u0211\23\0\1\u0212\31\0"+
    "\1\u0212\47\0\1\u0213\30\0\1\u0213\44\0\1\u0214\30\0"+
    "\1\u0214\41\0\1\u0215\30\0\1\u0215\33\0\1\u0216\30\0"+
    "\1\u0216\20\0\1\u0217\113\0\1\u0218\30\0\1\u0218\33\0"+
    "\1\u0219\30\0\1\u0219\21\0\1\u01fd\110\0\1\u021a\30\0"+
    "\1\u021a\16\0\1\u021b\75\0\1\u0195\1\0\1\u0196\6\0"+
    "\1\u0166\1\u0198\3\0\1\u021c\13\0\1\u0195\1\0\1\u0196"+
    "\5\0\1\u0166\1\u0198\3\0\1\u021c\35\0\1\u021d\30\0"+
    "\1\u021d\16\0\1\u021e\71\0\1\u01ff\74\0\1\u0195\1\0"+
    "\1\u0196\7\0\1\u0198\3\0\1\u021f\13\0\1\u0195\1\0"+
    "\1\u0196\6\0\1\u0198\3\0\1\u021f\40\0\1\u0220\30\0"+
    "\1\u0220\14\0\1\u0201\74\0\1\u0221\1\0\1\u0222\7\0"+
    "\1\u0223\3\0\1\u0224\13\0\1\u0221\1\0\1\u0222\6\0"+
    "\1\u0223\3\0\1\u0224\40\0\1\u0225\30\0\1\u0225\34\0"+
    "\1\u0226\30\0\1\u0226\36\0\1\u0227\30\0\1\u0227\44\0"+
    "\1\u0228\30\0\1\u0228\37\0\1\u0229\30\0\1\u0229\36\0"+
    "\1\u022a\30\0\1\u022a\34\0\1\u022b\30\0\1\u022b\45\0"+
    "\1\u022c\30\0\1\u022c\14\0\1\u022d\31\0\1\u022d\47\0"+
    "\1\u022e\30\0\1\u022e\40\0\1\u022f\30\0\1\u022f\42\0"+
    "\1\u0230\30\0\1\u0230\45\0\1\u0231\30\0\1\u0231\10\0"+
    "\1\u0232\123\0\1\u0233\52\0\1\u0234\30\0\1\u0234\25\0"+
    "\1\u0235\31\0\1\u0235\62\0\1\u01d9\30\0\1\u01d9\10\0"+
    "\1\u0236\61\0\2\u0232\2\0\3\u0232\1\u0237\30\u0232\2\0"+
    "\27\u0232\14\0\1\u0238\31\0\1\u0238\64\0\1\u0239\43\0"+
    "\1\u023a\31\0\1\u023a\21\0\2\u0236\2\0\3\u0236\1\u023b"+
    "\30\u0236\2\0\27\u0236\6\0\1\u023c\73\0\1\u023d\31\0"+
    "\1\u023d\53\0\1\u023e\30\0\1\u023e\42\0\1\u023f\30\0"+
    "\1\u023f\14\0\1\u0240\70\0\1\u023c\32\0\1\u0241\62\0"+
    "\1\u0242\30\0\1\u0242\40\0\1\u0243\30\0\1\u0243\12\0"+
    "\1\u0244\32\0\1\u0245\34\0\1\u0240\32\0\1\u0246\27\0"+
    "\40\u0247\1\0\30\u0247\15\0\1\u0248\31\0\1\u0248\46\0"+
    "\1\u0249\30\0\1\u0249\12\0\2\u0244\2\0\3\u0244\1\u024a"+
    "\30\u0244\2\0\27\u0244\37\0\1\u024b\30\0\1\u024b\40\u024c"+
    "\1\0\30\u024c\40\u0247\1\u024d\30\u0247\7\0\1\u0244\73\0"+
    "\1\u024e\31\0\1\u024e\32\0\1\u024f\77\0\1\u0250\31\0"+
    "\1\u0250\21\0\40\u024c\1\u0251\30\u024c\5\0\1\u0252\100\0"+
    "\1\u0253\31\0\1\u0253\27\0\1\u024f\32\0\1\u0254\40\0"+
    "\1\u0253\31\0\1\u0253\32\0\1\u0255\107\0\1\u0256\30\0"+
    "\1\u0256\44\0\1\u0248\30\0\1\u0248\6\0\40\u0257\1\0"+
    "\30\u0257\24\0\1\u0258\30\0\1\u0258\36\0\1\u0259\30\0"+
    "\1\u0259\14\0\40\u0257\1\u025a\30\u0257\23\0\1\u025b\30\0"+
    "\1\u025b\42\0\1\u025c\30\0\1\u025c\16\0\1\u025d\111\0"+
    "\1\u025e\30\0\1\u025e\52\0\1\u01fd\53\0\1\u025f\30\0"+
    "\1\u025f\54\0\1\u01ff\52\0\1\u0260\30\0\1\u0260\42\0"+
    "\1\u0261\30\0\1\u0261\52\0\1\u0262\27\0";

  private static int [] zzUnpacktrans() {
    int [] result = new int[34029];
    int offset = 0;
    offset = zzUnpacktrans(ZZ_TRANS_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpacktrans(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      value--;
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }


  /** Error code for "Unknown internal scanner error". */
  private static final int ZZ_UNKNOWN_ERROR = 0;
  /** Error code for "could not match input". */
  private static final int ZZ_NO_MATCH = 1;
  /** Error code for "pushback value was too large". */
  private static final int ZZ_PUSHBACK_2BIG = 2;

  /**
   * Error messages for {@link #ZZ_UNKNOWN_ERROR}, {@link #ZZ_NO_MATCH}, and
   * {@link #ZZ_PUSHBACK_2BIG} respectively.
   */
  private static final String ZZ_ERROR_MSG[] = {
    "Unknown internal scanner error",
    "Error: could not match input",
    "Error: pushback value was too large"
  };

  /**
   * ZZ_ATTRIBUTE[aState] contains the attributes of state {@code aState}
   */
  private static final int [] ZZ_ATTRIBUTE = zzUnpackAttribute();

  private static final String ZZ_ATTRIBUTE_PACKED_0 =
    "\3\0\1\11\1\1\1\11\1\1\1\11\1\1\12\0"+
    "\1\11\62\0\1\11\203\0\1\1\11\0\1\11\7\0"+
    "\1\11\4\0\2\11\u010c\0\1\1\1\11\11\0\1\1"+
    "\146\0\1\1";

  private static int [] zzUnpackAttribute() {
    int [] result = new int[610];
    int offset = 0;
    offset = zzUnpackAttribute(ZZ_ATTRIBUTE_PACKED_0, offset, result);
    return result;
  }

  private static int zzUnpackAttribute(String packed, int offset, int [] result) {
    int i = 0;       /* index in packed string  */
    int j = offset;  /* index in unpacked array */
    int l = packed.length();
    while (i < l) {
      int count = packed.charAt(i++);
      int value = packed.charAt(i++);
      do result[j++] = value; while (--count > 0);
    }
    return j;
  }

  /** Input device. */
  private java.io.Reader zzReader;

  /** Current state of the DFA. */
  private int zzState;

  /** Current lexical state. */
  private int zzLexicalState = YYINITIAL;

  /**
   * This buffer contains the current text to be matched and is the source of the {@link #yytext()}
   * string.
   */
  private char zzBuffer[] = new char[Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen())];

  /** Text position at the last accepting state. */
  private int zzMarkedPos;

  /** Current text position in the buffer. */
  private int zzCurrentPos;

  /** Marks the beginning of the {@link #yytext()} string in the buffer. */
  private int zzStartRead;

  /** Marks the last character in the buffer, that has been read from input. */
  private int zzEndRead;

  /**
   * Whether the scanner is at the end of file.
   * @see #yyatEOF
   */
  private boolean zzAtEOF;

  /**
   * The number of occupied positions in {@link #zzBuffer} beyond {@link #zzEndRead}.
   *
   * <p>When a lead/high surrogate has been read from the input stream into the final
   * {@link #zzBuffer} position, this will have a value of 1; otherwise, it will have a value of 0.
   */
  private int zzFinalHighSurrogate = 0;

  /** Number of newlines encountered up to the start of the matched text. */
  private int yyline;

  /** Number of characters from the last newline up to the start of the matched text. */
  private int yycolumn;

  /** Number of characters up to the start of the matched text. */
  private long yychar;

  /** Whether the scanner is currently at the beginning of a line. */
  @SuppressWarnings("unused")
  private boolean zzAtBOL = true;

  /** Whether the user-EOF-code has already been executed. */
  @SuppressWarnings("unused")
  private boolean zzEOFDone;

  /* user code: */
	
	S164_ReferencesMinistries() { }
	
	private String context = "";

	//Text of a single citation
	private StringBuilder text = new StringBuilder();
	
	//Textual buffer between single citations
	private StringBuilder buffer = new StringBuilder();
	
	private ArrayList<AnnotationEntity> references = new ArrayList<AnnotationEntity>(); //collection dei Reference presenti nello stesso Pattern

	private void startReference() {
	
		text = new StringBuilder();
		buffer = new StringBuilder();
		references = new ArrayList<AnnotationEntity>();
		
		annotationEntity = new Reference(Entity.LEG_REF);
		references.add(annotationEntity);
		
		context = Util.removeAllAnnotations(yytext());
		((Reference) annotationEntity).setContext(context);
		
		annotationEntity.setPosition(position);

		length = yylength();		
	
		yypushback(length);
		offset = 0;
	
		yybegin(referenceState);	 
	}
	
	private void checkReference() {
	
		if( ((Reference) annotationEntity).isReference() ) {
		
			((Reference) annotationEntity).setText(Util.removeAllAnnotations(text.toString()));
			((Reference) annotationEntity).setContext(context.toString());
			
			//Add shared features
			for(Entity key : ((Reference) annotationEntity).name2sharedEntity.keySet()) {
				
				if(annotationEntity.getRelatedEntity(key) == null) {
					
					annotationEntity.addRelatedEntity(((Reference) annotationEntity).name2sharedEntity.get(key));
				}
			}
			
			//Add inverse related properties
			for(AnnotationEntity relatedEntity : annotationEntity.getRelatedEntities()) {
			
				relatedEntity.addRelatedEntity(annotationEntity);
			}
			
			addEntity(annotationEntity);
			
		} else {
			
			addText(text.toString());
		}

		addText(buffer.toString());
		
		text = new StringBuilder();
		text.append(yytext());
		buffer = new StringBuilder();
	
		Reference newAnnotationEntity = new Reference(Entity.LEG_REF);
		
		references.add(newAnnotationEntity);
		
		newAnnotationEntity.setPosition(position);
		newAnnotationEntity.setContext(context);
		
		newAnnotationEntity.name2sharedEntity.putAll(((Reference) annotationEntity).name2sharedEntity);		
		
		annotationEntity = newAnnotationEntity;
	}

	private void readFeature(boolean isShared) {
	
		AnnotationEntity retrievedEntity = retrieveEntity();
		
		offset += yylength();

		if(isShared) {
		
			((Reference) annotationEntity).name2sharedEntity.put(retrievedEntity.getEntity(), retrievedEntity);
		}
		
		if(annotationEntity.getRelatedEntity(retrievedEntity.getEntity()) != null) {

			checkReference();

		} else {
		
			text.append(buffer.toString());
			text.append(yytext());
			buffer = new StringBuilder();
		}

		annotationEntity.addRelatedEntity(retrievedEntity);
		
		position += retrievedEntity.getText().length();
	}



  /**
   * Creates a new scanner
   *
   * @param   in  the java.io.Reader to read input from.
   */
  S164_ReferencesMinistries(java.io.Reader in) {
    this.zzReader = in;
  }


  /** Returns the maximum size of the scanner buffer, which limits the size of tokens. */
  private int zzMaxBufferLen() {
    return Integer.MAX_VALUE;
  }

  /**  Whether the scanner buffer can grow to accommodate a larger token. */
  private boolean zzCanGrow() {
    return true;
  }

  /**
   * Translates raw input code points to DFA table row
   */
  private static int zzCMap(int input) {
    int offset = input & 255;
    return offset == input ? ZZ_CMAP_BLOCKS[offset] : ZZ_CMAP_BLOCKS[ZZ_CMAP_TOP[input >> 8] | offset];
  }

  /**
   * Refills the input buffer.
   *
   * @return {@code false} iff there was new input.
   * @exception java.io.IOException  if any I/O-Error occurs
   */
  private boolean zzRefill() throws java.io.IOException {

    /* first: make room (if you can) */
    if (zzStartRead > 0) {
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
      System.arraycopy(zzBuffer, zzStartRead,
                       zzBuffer, 0,
                       zzEndRead - zzStartRead);

      /* translate stored positions */
      zzEndRead -= zzStartRead;
      zzCurrentPos -= zzStartRead;
      zzMarkedPos -= zzStartRead;
      zzStartRead = 0;
    }

    /* is the buffer big enough? */
    if (zzCurrentPos >= zzBuffer.length - zzFinalHighSurrogate && zzCanGrow()) {
      /* if not, and it can grow: blow it up */
      char newBuffer[] = new char[Math.min(zzBuffer.length * 2, zzMaxBufferLen())];
      System.arraycopy(zzBuffer, 0, newBuffer, 0, zzBuffer.length);
      zzBuffer = newBuffer;
      zzEndRead += zzFinalHighSurrogate;
      zzFinalHighSurrogate = 0;
    }

    /* fill the buffer with new input */
    int requested = zzBuffer.length - zzEndRead;
    int numRead = zzReader.read(zzBuffer, zzEndRead, requested);

    /* not supposed to occur according to specification of java.io.Reader */
    if (numRead == 0) {
      if (requested == 0) {
        throw new java.io.EOFException("Scan buffer limit reached ["+zzBuffer.length+"]");
      }
      else {
        throw new java.io.IOException(
            "Reader returned 0 characters. See JFlex examples/zero-reader for a workaround.");
      }
    }
    if (numRead > 0) {
      zzEndRead += numRead;
      if (Character.isHighSurrogate(zzBuffer[zzEndRead - 1])) {
        if (numRead == requested) { // We requested too few chars to encode a full Unicode character
          --zzEndRead;
          zzFinalHighSurrogate = 1;
        } else {                    // There is room in the buffer for at least one more char
          int c = zzReader.read();  // Expecting to read a paired low surrogate char
          if (c == -1) {
            return true;
          } else {
            zzBuffer[zzEndRead++] = (char)c;
          }
        }
      }
      /* potentially more input available */
      return false;
    }

    /* numRead < 0 ==> end of stream */
    return true;
  }


  /**
   * Closes the input reader.
   *
   * @throws java.io.IOException if the reader could not be closed.
   */
  public final void yyclose() throws java.io.IOException {
    zzAtEOF = true; // indicate end of file
    zzEndRead = zzStartRead; // invalidate buffer

    if (zzReader != null) {
      zzReader.close();
    }
  }


  /**
   * Resets the scanner to read from a new input stream.
   *
   * <p>Does not close the old reader.
   *
   * <p>All internal variables are reset, the old input stream <b>cannot</b> be reused (internal
   * buffer is discarded and lost). Lexical state is set to {@code ZZ_INITIAL}.
   *
   * <p>Internal scan buffer is resized down to its initial length, if it has grown.
   *
   * @param reader The new input stream.
   */
  public final void yyreset(java.io.Reader reader) {
    zzReader = reader;
    zzEOFDone = false;
    yyResetPosition();
    zzLexicalState = YYINITIAL;
    int initBufferSize = Math.min(ZZ_BUFFERSIZE, zzMaxBufferLen());
    if (zzBuffer.length > initBufferSize) {
      zzBuffer = new char[initBufferSize];
    }
  }

  /**
   * Resets the input position.
   */
  private final void yyResetPosition() {
      zzAtBOL  = true;
      zzAtEOF  = false;
      zzCurrentPos = 0;
      zzMarkedPos = 0;
      zzStartRead = 0;
      zzEndRead = 0;
      zzFinalHighSurrogate = 0;
      yyline = 0;
      yycolumn = 0;
      yychar = 0L;
  }


  /**
   * Returns whether the scanner has reached the end of the reader it reads from.
   *
   * @return whether the scanner has reached EOF.
   */
  public final boolean yyatEOF() {
    return zzAtEOF;
  }


  /**
   * Returns the current lexical state.
   *
   * @return the current lexical state.
   */
  public final int yystate() {
    return zzLexicalState;
  }


  /**
   * Enters a new lexical state.
   *
   * @param newState the new lexical state
   */
  public final void yybegin(int newState) {
    zzLexicalState = newState;
  }


  /**
   * Returns the text matched by the current regular expression.
   *
   * @return the matched text.
   */
  public final String yytext() {
    return new String(zzBuffer, zzStartRead, zzMarkedPos-zzStartRead);
  }


  /**
   * Returns the character at the given position from the matched text.
   *
   * <p>It is equivalent to {@code yytext().charAt(pos)}, but faster.
   *
   * @param position the position of the character to fetch. A value from 0 to {@code yylength()-1}.
   *
   * @return the character at {@code position}.
   */
  public final char yycharat(int position) {
    return zzBuffer[zzStartRead + position];
  }


  /**
   * How many characters were matched.
   *
   * @return the length of the matched text region.
   */
  public final int yylength() {
    return zzMarkedPos-zzStartRead;
  }


  /**
   * Reports an error that occurred while scanning.
   *
   * <p>In a well-formed scanner (no or only correct usage of {@code yypushback(int)} and a
   * match-all fallback rule) this method will only be called with things that
   * "Can't Possibly Happen".
   *
   * <p>If this method is called, something is seriously wrong (e.g. a JFlex bug producing a faulty
   * scanner etc.).
   *
   * <p>Usual syntax/scanner level error handling should be done in error fallback rules.
   *
   * @param errorCode the code of the error message to display.
   */
  private static void zzScanError(int errorCode) {
    String message;
    try {
      message = ZZ_ERROR_MSG[errorCode];
    } catch (ArrayIndexOutOfBoundsException e) {
      message = ZZ_ERROR_MSG[ZZ_UNKNOWN_ERROR];
    }

    throw new Error(message);
  }


  /**
   * Pushes the specified amount of characters back into the input stream.
   *
   * <p>They will be read again by then next call of the scanning method.
   *
   * @param number the number of characters to be read again. This number must not be greater than
   *     {@link #yylength()}.
   */
  public void yypushback(int number)  {
    if ( number > yylength() )
      zzScanError(ZZ_PUSHBACK_2BIG);

    zzMarkedPos -= number;
  }




  /**
   * Resumes scanning until the next regular expression is matched, the end of input is encountered
   * or an I/O-Error occurs.
   *
   * @return the next token.
   * @exception java.io.IOException if any I/O-Error occurs.
   */
  public int yylex() throws java.io.IOException
  {
    int zzInput;
    int zzAction;

    // cached fields:
    int zzCurrentPosL;
    int zzMarkedPosL;
    int zzEndReadL = zzEndRead;
    char[] zzBufferL = zzBuffer;

    int [] zzTransL = ZZ_TRANS;
    int [] zzRowMapL = ZZ_ROWMAP;
    int [] zzAttrL = ZZ_ATTRIBUTE;

    while (true) {
      zzMarkedPosL = zzMarkedPos;

      yychar+= zzMarkedPosL-zzStartRead;

      boolean zzR = false;
      int zzCh;
      int zzCharCount;
      for (zzCurrentPosL = zzStartRead  ;
           zzCurrentPosL < zzMarkedPosL ;
           zzCurrentPosL += zzCharCount ) {
        zzCh = Character.codePointAt(zzBufferL, zzCurrentPosL, zzMarkedPosL);
        zzCharCount = Character.charCount(zzCh);
        switch (zzCh) {
        case '\u000B':  // fall through
        case '\u000C':  // fall through
        case '\u0085':  // fall through
        case '\u2028':  // fall through
        case '\u2029':
          yyline++;
          yycolumn = 0;
          zzR = false;
          break;
        case '\r':
          yyline++;
          yycolumn = 0;
          zzR = true;
          break;
        case '\n':
          if (zzR)
            zzR = false;
          else {
            yyline++;
            yycolumn = 0;
          }
          break;
        default:
          zzR = false;
          yycolumn += zzCharCount;
        }
      }

      if (zzR) {
        // peek one character ahead if it is
        // (if we have counted one line too much)
        boolean zzPeek;
        if (zzMarkedPosL < zzEndReadL)
          zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        else if (zzAtEOF)
          zzPeek = false;
        else {
          boolean eof = zzRefill();
          zzEndReadL = zzEndRead;
          zzMarkedPosL = zzMarkedPos;
          zzBufferL = zzBuffer;
          if (eof)
            zzPeek = false;
          else
            zzPeek = zzBufferL[zzMarkedPosL] == '\n';
        }
        if (zzPeek) yyline--;
      }
      zzAction = -1;

      zzCurrentPosL = zzCurrentPos = zzStartRead = zzMarkedPosL;

      zzState = ZZ_LEXSTATE[zzLexicalState];

      // set up zzAction for empty match case:
      int zzAttributes = zzAttrL[zzState];
      if ( (zzAttributes & 1) == 1 ) {
        zzAction = zzState;
      }


      zzForAction: {
        while (true) {

          if (zzCurrentPosL < zzEndReadL) {
            zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
            zzCurrentPosL += Character.charCount(zzInput);
          }
          else if (zzAtEOF) {
            zzInput = YYEOF;
            break zzForAction;
          }
          else {
            // store back cached positions
            zzCurrentPos  = zzCurrentPosL;
            zzMarkedPos   = zzMarkedPosL;
            boolean eof = zzRefill();
            // get translated positions and possibly new buffer
            zzCurrentPosL  = zzCurrentPos;
            zzMarkedPosL   = zzMarkedPos;
            zzBufferL      = zzBuffer;
            zzEndReadL     = zzEndRead;
            if (eof) {
              zzInput = YYEOF;
              break zzForAction;
            }
            else {
              zzInput = Character.codePointAt(zzBufferL, zzCurrentPosL, zzEndReadL);
              zzCurrentPosL += Character.charCount(zzInput);
            }
          }
          int zzNext = zzTransL[ zzRowMapL[zzState] + zzCMap(zzInput) ];
          if (zzNext == -1) break zzForAction;
          zzState = zzNext;

          zzAttributes = zzAttrL[zzState];
          if ( (zzAttributes & 1) == 1 ) {
            zzAction = zzState;
            zzMarkedPosL = zzCurrentPosL;
            if ( (zzAttributes & 8) == 8 ) break zzForAction;
          }

        }
      }

      // store back cached position
      zzMarkedPos = zzMarkedPosL;

      if (zzInput == YYEOF && zzStartRead == zzCurrentPos) {
        zzAtEOF = true;
        return YYEOF;
      }
      else {
        switch (zzAction < 0 ? zzAction : ZZ_ACTION[zzAction]) {
          case 1:
            { addText();
	position++;
            }
          // fall through
          case 11: break;
          case 2:
            { addText();
		position++;
            }
          // fall through
          case 12: break;
          case 3:
            { offset++;
		position++;
		
		if(offset >= length) {
			
			if(offset > length) {
				yypushback(1);
				position--;
			}
			
			checkReference();
			
			yybegin(0);

		} else {

			buffer.append(yytext());
		}
            }
          // fall through
          case 13: break;
          case 4:
            { addText();
		position--; //account for the following {LKN_C} character
		yybegin(YYINITIAL);
            }
          // fall through
          case 14: break;
          case 5:
            { addText(); 
	yybegin(lkn);
            }
          // fall through
          case 15: break;
          case 6:
            { AnnotationEntity retrievedEntity = retrieveEntity();
		offset += yylength();
		position += retrievedEntity.getText().length();
		buffer.append(yytext());
            }
          // fall through
          case 16: break;
          case 7:
            { readFeature(false);
            }
          // fall through
          case 17: break;
          case 8:
            { readFeature(true);
            }
          // fall through
          case 18: break;
          case 9:
            { readFeature(true); 
	
		AnnotationEntity retrievedEntity = retrieveEntity();

		for(AnnotationEntity item : references) {
		
			if(item != annotationEntity && item.getRelatedEntity(retrievedEntity.getEntity()) == null) {
			
				item.addRelatedEntity(retrievedEntity);
			}
		}
            }
          // fall through
          case 19: break;
          case 10:
            { startReference();
            }
          // fall through
          case 20: break;
          default:
            zzScanError(ZZ_NO_MATCH);
        }
      }
    }
  }

  /**
   * Runs the scanner on input files.
   *
   * This is a standalone scanner, it will print any unmatched
   * text to System.out unchanged.
   *
   * @param argv   the command line, contains the filenames to run
   *               the scanner on.
   */
  public static void main(String[] argv) {
    if (argv.length == 0) {
      System.out.println("Usage : java S164_ReferencesMinistries [ --encoding <name> ] <inputfile(s)>");
    }
    else {
      int firstFilePos = 0;
      String encodingName = "UTF-8";
      if (argv[0].equals("--encoding")) {
        firstFilePos = 2;
        encodingName = argv[1];
        try {
          // Side-effect: is encodingName valid?
          java.nio.charset.Charset.forName(encodingName);
        } catch (Exception e) {
          System.out.println("Invalid encoding '" + encodingName + "'");
          return;
        }
      }
      for (int i = firstFilePos; i < argv.length; i++) {
        S164_ReferencesMinistries scanner = null;
        java.io.FileInputStream stream = null;
        java.io.Reader reader = null;
        try {
          stream = new java.io.FileInputStream(argv[i]);
          reader = new java.io.InputStreamReader(stream, encodingName);
          scanner = new S164_ReferencesMinistries(reader);
          while ( !scanner.zzAtEOF ) scanner.yylex();
        }
        catch (java.io.FileNotFoundException e) {
          System.out.println("File not found : \""+argv[i]+"\"");
        }
        catch (java.io.IOException e) {
          System.out.println("IO error scanning file \""+argv[i]+"\"");
          System.out.println(e);
        }
        catch (Exception e) {
          System.out.println("Unexpected exception:");
          e.printStackTrace();
        }
        finally {
          if (reader != null) {
            try {
              reader.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
          if (stream != null) {
            try {
              stream.close();
            }
            catch (java.io.IOException e) {
              System.out.println("IO error closing file \""+argv[i]+"\"");
              System.out.println(e);
            }
          }
        }
      }
    }
  }


}
